leedcode_1. 两数之和

问题:

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解题思路:


     这道题本身如果通过暴力遍历的话也是很容易解决的,时间复杂度在 O(n2),由于哈希查找的时间复杂度为 O(1),所以可以利用哈希容器 map 降低时间复杂度。遍历数组 nums,i 为当前下标,每个值都判断map中是否存在 target-nums[i] 的 key 值。如果存在则找到了两个值,如果不存在则将当前的 (nums[i],i) 存入 map 中,继续遍历直到找到为止。如果最终都没有结果,则返回null。时间复杂度:O(n)

代码:

    public static void main(String[] args)  {
        int[] nums ={2, 7, 11, 15};
        int target = 9;
        int[] twoSum = new test_1_sum().twoSum(nums, target);
        System.out.println(Arrays.toString(twoSum));
    }
    public int[] twoSum(int[] nums, int target) {
        HashMap map = new HashMap<>();
        for(int i=0;i

 

 

 

 

 

你可能感兴趣的:(leetcode)